#include <iostream>
#include <set>
#include <vector>
#include <map>
#define int long long
//zxc1000-7?
using namespace std;
//42 ей братуха 42
int main()
{
int t;
cin>>t;
    while(t--){
            map<int, int> natsum;
        int n;
        int o =0;
        int mx =0;
        int nat=0;
        int p = 0;
        int res =0;
        cin>>n;
        map<int, vector<int>> gl;
        map<pair<int, int>, int> sum;

        for(int i = 0;i<n;i++){

            int a,b,c;
            cin>>a>>b>>c;
            gl[a].push_back(b);
            gl[b].push_back(a);
            pair<int, int> pa;
            pair<int, int> pa1;
            pa.first = a;
            pa.second = b;
            pa1.first = b;
            pa1.second = a;
            natsum[a]+=c;
            natsum[b]+=c;
            if(natsum[a] > mx){
                mx = natsum[a];
                o= a;

            }
            else{
                if(natsum[b] > mx){
                    mx = natsum[b];
                    o = b;
                }
            }
            sum[pa] +=c;//мб треба +=
            sum[pa1] +=c;//тоже
        }//побудували дерево із дівчаток і порахували натуральну сумму для них

        pair<int, int> pa;
        pair<int, int> pa1;
        pair<int, int> pa2;
        for(int i = 1;i<n*2+1;i++){//проходимося по всім можливим дівчаткам навіть якщо вони нікому не подобаються
            //cout<<"divochka "<<i<<' ';//номер дівчинки
            for(int j = 0;j<gl[i].size();j++){
                    int p = 0;//проходимось по дівчаткам одного типажу
            pa.first = i;
            pa.second = gl[i][j];

            for(int y = j+1;y<gl[i].size();y++){
                    pa1.first = gl[i][j];
                    pa1.second = gl[i][y];
                    pair<int, int> pa2;
                    pa2.first = gl[i][y];
                    pa2.second = i;
                if(sum[pa1]!=0){

                    p = sum[pa] + sum[pa1] + sum[pa2];

                  //  cout<<" i "<<i<<" P "<<p;
                    if(p > mx){
                        mx = p;
                        o = i;
                      //  cout<<"I "<<i<<"p "<<p;
                      //  cout<<" "<<sum[pa]<<" "<<sum[pa1]<<" "<<sum[pa2];
                    }
                }

            }


            }

//cout<<"res divcha = "<<max(natsum[i], mx)<<endl;
    res = max(res, max(natsum[i], mx));
  //  mx = 0;
    nat=  natsum[i];
        }//
        cout<<mx<<endl;
    //mx = 0;
    //nat=  0;
    }
}
